Newer Version Available

This content describes an older version of this product. View Latest

Create Multiple Records with Fewer Round-Trips

Use a POST request with sObject Collections to add up to 200 records, returning a list of SaveResult objects. You can choose whether to roll back the entire request when an error occurs.

Request Syntax

POST /vXX.X/composite/sobjects

Parameters

Parameter Description
allOrNone Optional. Indicates whether to roll back the entire request when the creation of any object fails (true) or to continue with the independent creation of other objects in the request. The default is false.
records Required. A list of sObjects. In a POST request using sObject Collections, set the type attribute for each object, but don’t set the id field for any object.

Usage Guidelines

  • The list can contain up to 200 objects.
  • The list can contain objects of different types, including custom objects.
  • Each object must contain an attributes map. The map must contain a value for type.

    Using sObject Collections to insert blob data requires more values in the attributes map. For more information, see Using SObject Collections to Insert a Collection of Blob Records.

    Note

  • Objects are created in the order they’re listed. The SaveResult objects are returned in the order in which the create requests were specified.
  • If the request body includes objects of more than one type, they are processed as chunks. For example, if the incoming objects are {account1, account2, contact1, account3}, the request is processed in three chunks: {{account1, account2}, {contact1}, {account3}}. A single request can process up to 10 chunks.
  • A single request can process up to 10 chunks.
  • You can’t create records for multiple object types in one call when one of the types is related to a feature in the Salesforce Setup area.

Checking for Errors

  • If the request isn’t well formed, the API returns a 400 Bad Request HTTP Status. Fix the syntax of the request and try again.
  • If the request is well formed, the API returns a 200 OK HTTP Status. If an item was processed successfully, the success flag shows for that item. Error information is returned in the errors array.

Request Body Example

1POST /composite/sobjects
2{
3   "allOrNone" : false,
4   "records" : [{
5      "attributes" : {"type" : "Account"},
6      "Name" : "example.com",
7      "BillingCity" : "San Francisco"
8   }, {
9      "attributes" : {"type" : "Contact"},
10      "LastName" : "Johnson",
11      "FirstName" : "Erica"
12   }]
13}

Response Body Examples

This example shows a response when all the items were processed successfully.
1HTTP/1.1 200 OK
2
3[
4   {
5      "id" : "001RM000003oLnnYAE",
6      "success" : true,
7      "errors" : [ ]
8   },
9   {
10      "id" : "003RM0000068xV6YAI",
11      "success" : true,
12      "errors" : [ ]
13   }
14]
This example shows a response when some items caused errors and allOrNone is false.
1HTTP/1.1 200 OK
2
3[
4   {
5      "success" : false,
6      "errors" : [
7         {
8            "statusCode" : "DUPLICATES_DETECTED",
9            "message" : "Use one of these records?",
10            "fields" : [ ]
11         }
12      ]
13   },
14   {
15      "id" : "003RM0000068xVCYAY",
16      "success" : true,
17      "errors" : [ ]
18   }
19]
This example shows a response when some items caused errors and allOrNone is true.
1HTTP/1.1 200 OK
2
3[
4   {
5      "success" : false,
6      "errors" : [
7         {
8            "statusCode" : "DUPLICATES_DETECTED",
9            "message" : "Use one of these records?",
10            "fields" : [ ]
11         }
12      ]
13   },
14   {
15      "success" : false,
16      "errors" : [
17         {
18            "statusCode" : "ALL_OR_NONE_OPERATION_ROLLED_BACK",
19            "message" : "Record rolled back because not all records were valid and the request was using AllOrNone header",
20            "fields" : [ ]
21         }
22      ]
23   }
24]